module Chervil
  class Env
    attr_reader :data

    def initialize(parent = nil)
      @data = Hash.new

      Core::CORE.each do |k, v|
        set(k, v)
      end

      unless parent.nil?
        parent.data.each do |k, v|
          set(k, v)
        end
      end
    end

    def get(name)
      @data[name]
    end

    def set(name, value)
      @data[name] = value
    end
  end
end
